package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ProductImage;
import com.izouma.awesomeadmin.service.ProductImageService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/productImage")
@RequiresAuthentication
public class ProductImageController {

    @Autowired
    private ProductImageService productImageService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ProductImage record) {
        List<ProductImage> pp = productImageService.getProductImageList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getProductImage", method = RequestMethod.GET)
    @ResponseBody
    public Result getProductImage(@RequestParam(required = false, value = "id") String id) {
        ProductImage data = productImageService.getProductImageById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ProductImage record) {
        ProductImage data = productImageService.getProductImage(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ProductImage record) {
        Map<String, Object> result = new HashMap<>();

        List<ProductImage> pp =productImageService.getProductImageByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ProductImage record) {
        boolean num = productImageService.createProductImage(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateProductImage(ProductImage record) {
        boolean num = productImageService.updateProductImage(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteProductImage(@RequestParam(required = true, value = "id") String id) {

        boolean num = productImageService.deleteProductImage(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ProductImage record) throws Exception {

    List<ProductImage> productImages = productImageService.getProductImageList(record);


        String sheetName = "product_image";
        String titleName = "商品图片数据表";
        String fileName = "商品图片表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "产品" ,   "图片" ,   "备注" ,   "排序" ,   "名称"  };
        String[][] dataList = new String[productImages.size()][11];

        for (int i = 0; i < productImages.size(); i++) {

                        dataList[i][0] = String.valueOf(productImages.get(i).getId());
                        dataList[i][1] = String.valueOf(productImages.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(productImages.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(productImages.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(productImages.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(productImages.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(productImages.get(i).getProductId());
                        dataList[i][7] = String.valueOf(productImages.get(i).getImage());
                        dataList[i][8] = String.valueOf(productImages.get(i).getRemark());
                        dataList[i][9] = String.valueOf(productImages.get(i).getRank());
                        dataList[i][10] = String.valueOf(productImages.get(i).getName());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

